 /* ppacas  .c   GG630504 */

 /* Adatok s fggvnyek a tstcas.c s ibmht.c programokhoz.
    Lers az ibmcas.htm llomnyban. */

 /* A  program  alapja  rvid  idk  mrse  - programmal. Ezrt minden zavar
 krlmnyt ki kell zrni, ha csak lehet. Minden megszaktst letilt a program
 -- kivve a billentyzett, de azt is trja. A lehet leggyorsabbra clszer
 fordtani, ( kivve a ciklusok optimalizlst ), ez gyben lsd a PPACAS.CFG
 konfigurcis llomnyt. */

#include <conio.h>
#include <dos.h>
#include <stdio.h>

#ifndef inclPpacasH
#include "ppacas.h"
#endif

#define ioItCtrl1  0x21
#define iItKbd     0x09

volatile F         fKbd;
IOB                iobPpa;
IO                 ioPpaSt;

static B           bItcSav;
static PFV_INTR    pfvintrKbdSav;

 /*------------------------------------------------------------------------*/
 /* Uj megszaktsrutin a billentyzetnek */

void interrupt     KbdTmp( V )
 {
 fKbd = fTrue;
 pfvintrKbdSav();
 }

 /*------------------------------------------------------------------------*/

V                  StartCasIn( V )
 {
 /* a nyomtatadapter elksztse ( kondi feltlts ) */
 outportb( iobPpa+iooPpaDat, 0 );
 outportb( iobPpa+iooPpaCmd, 0 );

 delay( 100 );

 while ( kbhit() )
       getch();

 /* megszaktsvezrl belltasa ( billentyzet kivtelvel minden tiltva ) */
 bItcSav = inportb( ioItCtrl1 );
 outportb( ioItCtrl1, 0xFD );
 outportb( ioItCtrl1, 0xFD );

 /* uj billentyzetrutin befzse */
 pfvintrKbdSav = getvect( iItKbd );
 setvect( iItKbd, KbdTmp );

 /* nem volt billentylets */
 fKbd = fFalse;
 }

 /*------------------------------------------------------------------------*/

V                  StopCasIn( V )
 {
 /* eredeti megszaktsok visszalltsa */
 outportb( ioItCtrl1, bItcSav );
 outportb( ioItCtrl1, bItcSav );

 /* eredeti billentyzetrutin visszalltsa */
 setvect( iItKbd, pfvintrKbdSav );

 while ( kbhit() )
       getch();
 }

 /*------------------------------------------------------------------------*/

R                  RInitCasIn( V )
 {
 delay( 1 );

 /* nyomtatcmek a BIOS-tl */
 iobPpa  = mpIobPpaC[ 0 ];
 ioPpaSt = iobPpa+iooPpaSt;

 if ( iobPpa==0 )
      {
      fprintf( stderr, "A gpben egy rva nyomtatvezrlt, "
                       "annyit sem talltam.\n" );
      return rError;
      }
 else return rOk;
 }

 /*^^^*/
