 /* priht   .c   GG630504 */

 /* HT llomnyt listz program.
    Lers az ibmcas.htm llomnyban. */

#include <fcntl.h>
#include <io.h>
#include <stdio.h>
#include <string.h>

#ifndef inclPpacasH
#include "ppacas.h"
#endif

CH                 szInf[80];

 /*------------------------------------------------------------------------*/

V                  PrintAsm( V )
 {
 C                 cTmp;

 fprintf( stdout, ". Name: " );
 ibCur = 1;
 for ( cTmp = 0; cTmp<6; ++cTmp )
     {
     bTmp = BRead();
     fprintf( stdout, "%c", bTmp );
     }
 fprintf( stdout, " (%s)\n", szInf );

 bTmp = BRead();
 while ( bTmp!=0x1A && !FEof() )
       {
       bTmp = BRead(); /* itt van sszesen 6 byte, ami valami */
       bTmp = BRead();
       bTmp = BRead();
       bTmp = BRead();
       bTmp = BRead();
       bTmp = BRead();
       fprintf( stdout, "\n" );
       while ( bTmp!=0x0D && !FEof() )
             {
             fprintf( stdout, "%c", bTmp );
             bTmp = BRead();
             }
       bTmp = BRead();
       }
 fprintf( stdout, "\n" );
 }

 /*------------------------------------------------------------------------*/

V                  PrintBasic( V )
 {
 F                 fRem;
 F                 fSlit;
 U                 uAddr;
 U                 uLin;

 ibCur = 3;
 bTmp = BRead();
 fprintf( stdout, ". Name: %c (%s)\n", bTmp, szInf );
 uAddr = URead();
 while ( uAddr!=0 && !FEof() )
       {
       fSlit = fFalse;
       fRem  = fFalse;
       uLin  = URead(); /* sorszm */
       fprintf( stdout, "\n%u ", uLin );
       bTmp = BRead();
       while ( bTmp!=0 && !FEof() )
             {
             if ( fSlit || fRem ) /* string konstans vagy megjegyzs */
             then {
                  switch ( bTmp )
                         {
                  case 0x0A: bTmp = '\n'; break;
                  case '}':  bTmp = '';  break;
                  case '|':  bTmp = '';  break;
                  case '`':  bTmp = '';  break;
                  case '\\': bTmp = '';  break;
                         }
                  fprintf( stdout, "%c", bTmp );
                  if ( fSlit && bTmp=='\"' )
                  then fSlit = fFalse;
                  }
             else { /* nem ( string konstans vagy megjegyzs ) */
                  switch ( bTmp )
                         {
                  case ':':
                       bTmp = BRead();
                       if ( FEof() )
                       then break;
                       switch ( bTmp )
                              {
                       case 0x93: /* rem */
                            bTmp = BRead();
                            fprintf( stdout, "`" );
                            fRem = fTrue;
                            break;
                       case 0x95: /* else */
                            --ibCur;
                            break;
                       default: /* ms */
                            fprintf( stdout, ":" );
                            --ibCur;
                            break;
                              }
                       break;

                  case 0xB9: /* cload */
                       fprintf( stdout, "%s", rgTok[bTmp-0x80].szTok );
                       bTmp = BRead();
                       if ( FEof() )
                       then break;
                       if ( bTmp==0xB2 ) /* print */
                       then fprintf( stdout, "?" );
                       else --ibCur;
                       break;

                  default:
                       if ( bTmp>=0x80 )
                       then fprintf( stdout, "%s", rgTok[bTmp-0x80].szTok );
                       else {
                            fprintf( stdout, "%c", bTmp );
                            if ( bTmp=='\"' )
                            then fSlit = fTrue;
                            }
                       if ( bTmp == 0x93 )
                       then fRem = fTrue;
                       break;
                         }
                  }
             bTmp = BRead();
             }
       uAddr = URead();
       }
 fprintf( stdout, "\n" );
 }

 /*------------------------------------------------------------------------*/

V                  PrintCode( V )
 {
 B                 bsTmp; /* ell. ssz. */
 C                 cMac;
 C                 cTmp;

 fprintf( stdout, ". Name: " );
 ibCur = 1; /* nv 6 karakter */
 for ( cTmp = 0; cTmp<6; ++cTmp )
     {
     bTmp = BRead();
     fprintf( stdout, "%c", bTmp );
     }
 fprintf( stdout, " (%s)\n", szInf );

 bTmp = BRead(); /* blokk tpus */
 while ( bTmp==0x3C && !FEof() )
       {
       bTmp  = BRead(); /* byte-ok szma */
       cMac  = bTmp==0 ? 0x100 : bTmp;

       bTmp  = BRead(); /* betltsi cm */
       bsTmp = bTmp; /* innen vdett ell. ssz.-el */
       uTmp  = bTmp;

       bTmp  = BRead();
       bsTmp += bTmp;
       uTmp  += bTmp<<8;

       fprintf( stdout, "\nBokk: %02X (%3u) byte, cm %04X (%5u).",
                                 cMac,  cMac,         uTmp,  uTmp );

       for ( cTmp = 0; cTmp<cMac && !FEof(); ++cTmp )
             {
             if ( ( cTmp % 16 ) == 0 )
             then {
                  fprintf( stdout, "\n%04X (%5u)  ", uTmp+cTmp, uTmp+cTmp );
                  }
             bTmp  = BRead();
             bsTmp += bTmp;
             fprintf( stdout, "%02X ", bTmp );
             }

       bTmp = BRead(); /* ell. ssz. */
       fprintf( stdout,
                "\nBeolvasott ellenrzsszeg %02X, szmtott: %02X.\n",
                                              bTmp,            bsTmp );
       bTmp = BRead();
       }

 if ( bTmp==0x78 && !FEof() )
 then {
      uTmp = URead();
      fprintf( stdout, "\nStart cm: %04X (%5u).\n", uTmp, uTmp );
      }

 fprintf( stdout, "\n" );
 }

 /*------------------------------------------------------------------------*/

V                  PrintData( V )
 {
 fprintf( stdout, ". (%s)\n", szInf );
 while ( !FEof() )
       {
       bTmp = BRead();
       fprintf( stdout, "%c", bTmp );
       }
 fprintf( stdout, "\n" );
 }

 /*------------------------------------------------------------------------*/

R cdecl            main( cv_, pszv_, psze_ )
 C                 cv_;
 PSZ               pszv_;
 PSZ               psze_;
 {
 fprintf( stderr, "HT-1080Z llomnyt listz. " szPrgr ".\n" );

 if ( cv_>1 )
 then strcpy( szInf, pszv_[1] );
 else strcpy( szInf, szHt );

 if ( RLoadHtSz( szInf )==rOk )
 then {
      fprintf( stdout, "\r" );
      PriHtTypePfile( stdout );
      switch ( bHtType )
             {
      case bHtData:  PrintData();  break;
      case bHtBasic: PrintBasic(); break;
      case bHtCode:  PrintCode();  break;
      case bHtAsm:   PrintAsm();   break;
             }
      }
 else fprintf( stderr, "PRIHT [forrs_llomny] [>lista_llomny]\n" );

 return 0;
 }

 /*^^^*/
