 /* gwht    .c   GG630504 */

 /* GW Basic-re konvertl program HT Basic-rl.
    Lers az ibmcas.htm llomnyban. */

#include <fcntl.h>
#include <io.h>
#include <stat.h>
#include <stdio.h>
#include <string.h>

#ifndef inclPpaCasH
#include "ppacas.h"
#endif

#define Error() \
 {\
 fprintf( stderr, szWriteError, szOut );\
 close( hfOut );\
 return ;\
 }

CH                 szIn[80];
CH                 szOut[80];
CH                 szWriteError[] = "Hiba a %s llomnyba val kirskor.\n";

 /*------------------------------------------------------------------------*/

V                  GwFromHt( V )
 {
 B                 bTok;
 F                 fRem;
 F                 fSlit;
 C                 hfOut;
 U                 uAddr;
 U                 uLin;

 hfOut = open( szOut, O_RDWR  | O_CREAT | O_BINARY,
                      S_IFREG | S_IREAD | S_IWRITE );
 if ( hfOut<0 )
 then {
      fprintf( stderr, "Nem tudtam megnyitni a %s llomnyt.\n", szOut );
      return;
      }

 bTmp = 0xFF;
 if ( write( hfOut, &bTmp, 1 )<0 )
 then Error();

 ibCur = 4;

 uAddr = URead();
 while ( uAddr!=0 && !FEof() )
       {
       uTmp = 0x1111;
       if ( write( hfOut, &uTmp, 2 )<0 )
       then Error();

       fSlit = fFalse;
       fRem  = fFalse;
       uLin  = URead(); /* sorszm */
       if ( write( hfOut, &uLin, 2 )<0 )
       then Error();
       bTmp = BRead();
       while ( bTmp!=0 && !FEof() )
             {
             if ( fSlit || fRem ) /* string konstans vagy megjegyzs */
             then {
                  switch ( bTmp )
                         {
                  case 0x0A: bTmp = 0x0D; /* CR -> CR LF */
                             if ( write( hfOut, &bTmp, 1 )<0 )
                             then Error();
                             bTmp = 0x0A;
                             break;
                  case '}':  bTmp = '';  break;
                  case '|':  bTmp = '';  break;
                  case '`':  bTmp = '';  break;
                  case '\\': bTmp = '';  break;
                         }
                  if ( write( hfOut, &bTmp, 1 )<0 )
                  then Error();

                  if ( fSlit && bTmp=='\"' )
                  then fSlit = fFalse;
                  }
             else { /* nem ( string konstans vagy megjegyzs ) */
                  switch ( bTmp )
                         {

                  case 0xB9: /* cload */
                       bTok = bTmp-0x80;
                       if ( write( hfOut, rgTok[bTok].szTok,
                                   strlen(rgTok[bTok].szTok) )<0 )
                       then Error();
                       bTmp = BRead();
                       if ( FEof() )
                       then break;
                       if ( bTmp==0xB2 ) /* print */
                       then {
                            bTmp = '?';
                            if ( write( hfOut, &bTmp, 1 )<0 )
                            then Error();
                            }
                       else --ibCur;
                       break;

                  default:
                       if ( bTmp>=0x80 )
                       then { /* token-konverter */
                            bTok = bTmp-0x80;
                            if ( rgTok[bTok].bTok0==0 )
                            then {
                                 if ( write( hfOut,
                                      rgTok[bTok].szTok,
                                      strlen(rgTok[bTok].szTok) )<0 )
                                 then Error();
                                 }
                            else {
                                 if ( write( hfOut, &rgTok[bTok].bTok0, 1 )<0 )
                                 then Error();
                                 if ( rgTok[bTok].bTok1!=0 )
                                 then {
                                      if ( write( hfOut,
                                           &rgTok[bTok].bTok1, 1 )<0 )
                                      then Error();
                                      }
                                 }
                            }
                       else { /* nem token */
                            /* itt kellene a szmokat konvertlni. */
                            if ( write( hfOut, &bTmp, 1 )<0 )
                            then Error();
                            if ( bTmp=='\"' )
                            then fSlit = fTrue;
                            }
                       if ( bTmp == 0x93 )
                       then fRem = fTrue;
                       break;
                         }
                  }
             bTmp = BRead();
             }
       bTmp = 0; /* sor vge */
       if ( write( hfOut, &bTmp, 1 )<0 )
       then Error();
       uAddr = URead();
       }

 uTmp = 0;
 if ( write( hfOut, &uTmp, 2 )<0 )
 then Error();

 bTmp = 0x1A;
 if ( write( hfOut, &bTmp, 1 )<0 )
 then Error();

 if ( close( hfOut )<0 )
 then fprintf( stderr, "Hiba a %s llomny lezrsnl.\n", szOut );
 }

 /*------------------------------------------------------------------------*/

R cdecl            main( cv_, pszv_, psze_ )
 C                 cv_;
 PSZ               pszv_;
 PSZ               psze_;
 {
 fprintf( stderr,
          "GW Basic-re konvertl program HT-1080Z Basic-rl. " szPrgr ".\n" );

 if ( cv_>1 )
 then strcpy( szIn, pszv_[1] );
 else strcpy( szIn, szHt );

 if ( cv_>2 )
 then strcpy( szOut, pszv_[2] );
 else strcpy( szOut, "ht.bas" );

 if ( RLoadHtSz( szIn )==rOk )
 then if ( bHtType==bHtBasic )
      then GwFromHt();
      else fprintf( stderr, "Sajnos ez nem HT-Basic llomny.\n" );
 else fprintf( stderr, "GWHT [HT_forrs_llomny [GW_eredmny_llomny]]\n" );

 return 0;
 }

 /*^^^*/
