 /* ibmht   .c   GG630504 */

 /* ibm-be HT-1080Z llomnyt beolvas program.
    Lers az ibmcas.htm llomnyban. */

#include <conio.h>
#include <dos.h>
#include <stdio.h>
#include <stdlib.h>

#ifndef inclPpacasH
#include "ppacas.h"
#endif

B                  bData;
C                  cBcMac = 0;
C                  cT0;
C                  cT1    = cT1_;
C                  cT2;
F                  fTimeOut;   /* volt idtllps (drop out) */
B                  rgb[ibMax];

 /*------------------------------------------------------------------------*/
 /* itt nincs billentyzetfigyels, csak idfigyels.
    bData-ba shiftel egy bitet. */

V near pascal      ShBitHt( V )
 {
 C                 cT;

 /* vr a startbit felfut lre. */
 for ( cT = 0; (inportb( ioPpaSt ) & bPpaAck)==0; ++cT )
     if ( cT>cT0 )
          {
          fTimeOut = fTrue;
          return;
          }

 /* vr a felfut ltl cT1 ideig. */
 for ( cT = 0; cT< cT1; ++cT )
       ;

 bData <<= 1;
 if ( inportb( ioPpaSt ) & bPpaAck )
      bData |= 0x01;

 /* vr cT2 ideig. */
 for ( cT = 0; cT<cT2; ++cT )
     ;
 }

 /*------------------------------------------------------------------------*/

V                  LoadHt( V )
 {
 C                 c;
 C                 c0;

#ifdef CGA
 outportb( ioCgaPal, GREEN );
#endif

 StartCasIn();

    /*  vr  a  bevezet  0  byte-okra.  Ha  legalbb 10 bejtt bellk, akkor
 tovbblp, egybknt jrakezdi a szmllst. */

 bData = 0;
 c0    = 0;
 while ( c0<80 && !fKbd ) /* 10 db 0 byte = 80 db 0 bit */
       {
       fTimeOut = fFalse;
       ShBitHt();
       if ( bData!=0 || fTimeOut )
            c0 = 0;
       else c0++;
       }

 /* itt az ideje megkeresni a szinkronbyte-ot. Addig lptet, amg nem tall. */

#ifdef CGA
 outportb( ioCgaPal, RED );
#endif

 bData = 0;
 fTimeOut = fFalse; /* innentl id */
 while ( bData!=0xA5 && !fKbd && !fTimeOut )
       ShBitHt();

 for ( c = 0; c<ibMax && !fKbd && !fTimeOut; ++c )
     {

    /* 1 byte-nak ugye  8 bitje van. Az  els legyen SRGA, mint  a NARANCS, a
 tbbi TERMSZETESEN ZLD  CGA-n. Sem startbit,  sem stopbit, sem  paritsbit,
 semmi laca-faca, bitek, bitek, bitek... drop out-ig. */

#ifdef CGA
     outportb( ioCgaPal, YELLOW );
#endif

     if ( !fTimeOut )
          ShBitHt();

#ifdef CGA
     outportb( ioCgaPal, GREEN );
#endif

     if ( !fTimeOut )
          ShBitHt();
     if ( !fTimeOut )
          ShBitHt();
     if ( !fTimeOut )
          ShBitHt();
     if ( !fTimeOut )
          ShBitHt();
     if ( !fTimeOut )
          ShBitHt();
     if ( !fTimeOut )
          ShBitHt();
     if ( !fTimeOut )
          ShBitHt();
     rgb[c] = bData;
     }

 StopCasIn();
 cBcMac = c>0 ? c-1 : 0;
 }

 /*------------------------------------------------------------------------*/
 /* Kimenti a buffert egy llomnyba. */

V                  SaveB( V )
 {
 FILE *            phf;

 if ( cBcMac>2 ) /* 1 byte nem byte */
      {
      phf = fopen( "h.ht", "wb" );
      fwrite( rgb, 1, cBcMac, phf );
      fclose( phf );
      }
 }

 /*------------------------------------------------------------------------*/
    /* Ha nem te ltted le a programot, akkor csilingel, hogy megllthatsd  a
 magnt. Ezt nevezik flautomata biomanulis tvvezrlsnek. */

V                  Beep( V )
 {
 C                 cTmp;

 if ( !fKbd )
 then {

#ifdef CGA
      outportb( ioCgaPal, BLACK );
#endif

      for ( cTmp = 1; cTmp<5; ++cTmp )
          {
          sound( 1000 );
          delay( 55 );
          sound( 1200 );
          delay( 55 );
          }
      nosound();
      }

#ifdef CGA
 outportb( ioCgaPal, GREEN );
#endif

 }

 /*------------------------------------------------------------------------*/

R cdecl            main( cv_, pszv_, psze_ )
 C                 cv_;
 PSZ               pszv_;
 PSZ               psze_;
 {
 fprintf( stderr, "HT-1080Z kazetts llomny beolvas. " szPrgr ".\n" );

 if ( RInitCasIn()==rOk )
 then {
      /* Megadhatod az idllandt. */
      if ( cv_>1 )
      then {
           cT1 = atoi( pszv_[1] );
           if ( cT1<10 )
           then {
                cT1 = 10;
                fprintf( stderr, "IBMHT [idlland]" );
                }
           }
      cT0 = 2*cT1;
      cT2 = cT1/3;

      fprintf( stderr, "Nyomtatcm 0x%04X, idlland %d, ",
                                    iobPpa,            cT1 );
      LoadHt();
      printf( "%d byte-ot olvastam be.\n", cBcMac );
      Beep();
      SaveB();
      }
 return 0;
 }

 /*^^^*/
