 /* ppacas  .h   GG630504 */

#ifndef inclPpacasH
#define inclPpacasH

        /* Ha nem CGA krtys a gped, trld a kvetkez sort! */

#define CGA

        /* Itt kell a Sajt gpedhez szksges idllandt bernod.
           Az ibmht.c program hasznlja.
           420 == 80286, 10 MHz */

#define cT1_       420

 /*------------------------------------------------------------------------*/

#define szPrgr     "GG630504"
#define fFalse     0
#define fTrue      1
#define rError     (-2)
#define rOk        0
#define then

typedef unsigned       char        B;   /* byte */
typedef unsigned       int         C;   /* count... */
typedef unsigned       char        CH;  /* 1 char */
typedef unsigned       char        F;   /* flag, boolean */
typedef unsigned       int         IO;  /* io port addr ( iob+ioo ) */
typedef unsigned       int         IOB; /* io port addr base */
typedef unsigned       int         IOO; /* io port addr offset */
typedef signed   long  int         L;   /* long int */
typedef unsigned       char *   *  PSZ; /* pointer to SZ */
typedef signed         int         R;   /* return code */
typedef unsigned       char     *  SZ;  /* zero terminated string */
typedef unsigned       int         U;   /* word */
typedef void                       V;   /* void */
typedef signed         int         W;   /* int */

typedef V interrupt ( * PFV_INTR ) ( V );

 /*------------------------------------------------------------------------*/

#define bPpaAck    0x40 /* Ack bit maszkja */
#define ioCgaPal   0x3d9
#define iooPpaCmd  2
#define iooPpaDat  0
#define iooPpaSt   1
#define mpIobPpaC  ((IOB far *)0x00400008L) /* [4] */

extern volatile F  fKbd;
extern IOB         iobPpa;
extern IO          ioPpaSt;

V                  StartCasIn( V );
V                  StopCasIn( V );
R                  RInitCasIn( V );

 /*------------------------------------------------------------------------*/

#define bHtAsm     0
#define bHtBasic   1
#define bHtCode    2
#define bHtData    3
#define BRead()    (FEof()?0:rgb[ibCur++])
#define FEof()     (ibCur>=ibMac)
#define ibMax      0xC000u
#define szHt       "HT.HT"

typedef struct     {         /* HT tokentbla + GW <- HT konverzi */
 SZ                szTok;
 B                 bTok0;
 B                 bTok1;
 }                 TOK;

extern B           bHtType;
extern B           bTmp;
extern U           ibCur;
extern U           ibMac;
extern SZ          mpSzBht[];
extern B           rgb[];
extern TOK         rgTok[];
extern U           uTmp;

R                  RLoadHtSz( SZ );
U                  URead( V );
V                  PriHtTypePfile( FILE * );

#endif

 /*^^^*/
